# Create Subscription POST https://api.shipbob.com/2025-07/webhook Content-Type: application/json This endpoint creates a new webhook subscription. Reference: https://developer.shipbob.com/api/webhooks/create-subscription ## OpenAPI Specification ```yaml openapi: 3.1.0 info: title: api-2025-07 version: 1.0.0 paths: /2025-07/webhook: post: operationId: create-subscription summary: | Create Subscription description: | This endpoint creates a new webhook subscription. tags: - subpackage_webhooks parameters: - name: Authorization in: header description: Authentication using Personal Access Token (PAT) token required: true schema: type: string responses: '200': description: Success content: application/json: schema: $ref: '#/components/schemas/Webhooks.V2.Create.WebhookViewModelV2' '401': description: No access right at this time content: application/json: schema: description: Any type '403': description: No access content: application/json: schema: description: Any type '422': description: Client Error content: application/json: schema: $ref: '#/components/schemas/Webhooks.UnprocessableEntityObjectResult' requestBody: content: application/json: schema: $ref: '#/components/schemas/Webhooks.V2.CreateSubscriptionRequest' servers: - url: https://api.shipbob.com - url: https://sandbox-api.shipbob.com components: schemas: Webhooks.Topics: type: string enum: - order.shipped - order.shipment.delivered - order.shipment.exception - order.shipment.on_hold - order.shipment.cancelled title: Webhooks.Topics Webhooks.V2.CreateSubscriptionRequest: type: object properties: description: type: - string - 'null' description: Description of the webhook subscription. secret: type: - string - 'null' description: >- A secret key used to sign the webhook payload for verifying its authenticity on the receiver's end. topics: type: array items: $ref: '#/components/schemas/Webhooks.Topics' description: The event types for which webhook callbacks will be received. url: type: string format: uri description: "The URL that will be called when an event matching the subscription topic occurs.\r\nThe URL must use HTTPS, accept POST requests, and handle content of type application/json." required: - topics - url title: Webhooks.V2.CreateSubscriptionRequest Webhooks.V2.Create.WebhookViewModelV2: type: object properties: created_at: type: string format: date-time description: TimeStamp the webhook subscription was created description: type: - string - 'null' description: Description of the webhook subscription id: type: string description: ID of the webhook subscription secret: type: string description: >- A secret key used to sign the webhook payload for verifying its authenticity on the receiver's end. topics: type: array items: $ref: '#/components/schemas/Webhooks.Topics' description: List of event types the webhook will receive notifications for url: type: string description: URL subscription events will be posted to title: Webhooks.V2.Create.WebhookViewModelV2 WebhooksObjectResultDeclaredType1: oneOf: - type: string - type: string - type: string title: WebhooksObjectResultDeclaredType1 WebhooksObjectResultDeclaredType9: oneOf: - type: string title: WebhooksObjectResultDeclaredType9 WebhooksObjectResultDeclaredType10: oneOf: - type: string - type: string - type: string title: WebhooksObjectResultDeclaredType10 WebhooksObjectResultDeclaredType124: oneOf: - type: string title: WebhooksObjectResultDeclaredType124 WebhooksObjectResultDeclaredType125: oneOf: - type: string - type: string - type: string title: WebhooksObjectResultDeclaredType125 WebhooksObjectResultDeclaredType12: oneOf: - type: string - type: string - type: string - type: string - $ref: '#/components/schemas/WebhooksObjectResultDeclaredType124' - $ref: '#/components/schemas/WebhooksObjectResultDeclaredType125' - type: string title: WebhooksObjectResultDeclaredType12 WebhooksObjectResultDeclaredType144: oneOf: - type: string title: WebhooksObjectResultDeclaredType144 WebhooksObjectResultDeclaredType146: oneOf: - type: string title: WebhooksObjectResultDeclaredType146 WebhooksObjectResultDeclaredType147: oneOf: - type: string title: WebhooksObjectResultDeclaredType147 WebhooksObjectResultDeclaredType14: oneOf: - type: string - type: string - type: string - type: string - $ref: '#/components/schemas/WebhooksObjectResultDeclaredType144' - type: string - $ref: '#/components/schemas/WebhooksObjectResultDeclaredType146' - $ref: '#/components/schemas/WebhooksObjectResultDeclaredType147' - type: string - type: string title: WebhooksObjectResultDeclaredType14 WebhooksObjectResultDeclaredType17: oneOf: - type: string title: WebhooksObjectResultDeclaredType17 WebhooksObjectResultDeclaredType19: oneOf: - type: string title: WebhooksObjectResultDeclaredType19 WebhooksObjectResultDeclaredType20: oneOf: - type: string title: WebhooksObjectResultDeclaredType20 WebhooksObjectResultDeclaredType: oneOf: - type: string - $ref: '#/components/schemas/WebhooksObjectResultDeclaredType1' - type: string - type: string - type: string - type: string - type: string - type: string - type: string - $ref: '#/components/schemas/WebhooksObjectResultDeclaredType9' - $ref: '#/components/schemas/WebhooksObjectResultDeclaredType10' - type: string - $ref: '#/components/schemas/WebhooksObjectResultDeclaredType12' - type: string - $ref: '#/components/schemas/WebhooksObjectResultDeclaredType14' - type: string - type: string - $ref: '#/components/schemas/WebhooksObjectResultDeclaredType17' - type: string - $ref: '#/components/schemas/WebhooksObjectResultDeclaredType19' - $ref: '#/components/schemas/WebhooksObjectResultDeclaredType20' - type: string - type: string title: WebhooksObjectResultDeclaredType Webhooks.IOutputFormatter: type: object properties: {} title: Webhooks.IOutputFormatter WebhooksObjectResultValue: type: object properties: {} title: WebhooksObjectResultValue WebhooksUnprocessableEntityObjectResultDeclaredType1: oneOf: - type: string - type: string - type: string title: WebhooksUnprocessableEntityObjectResultDeclaredType1 WebhooksUnprocessableEntityObjectResultDeclaredType9: oneOf: - type: string title: WebhooksUnprocessableEntityObjectResultDeclaredType9 WebhooksUnprocessableEntityObjectResultDeclaredType10: oneOf: - type: string - type: string - type: string title: WebhooksUnprocessableEntityObjectResultDeclaredType10 WebhooksUnprocessableEntityObjectResultDeclaredType124: oneOf: - type: string title: WebhooksUnprocessableEntityObjectResultDeclaredType124 WebhooksUnprocessableEntityObjectResultDeclaredType125: oneOf: - type: string - type: string - type: string title: WebhooksUnprocessableEntityObjectResultDeclaredType125 WebhooksUnprocessableEntityObjectResultDeclaredType12: oneOf: - type: string - type: string - type: string - type: string - $ref: >- #/components/schemas/WebhooksUnprocessableEntityObjectResultDeclaredType124 - $ref: >- #/components/schemas/WebhooksUnprocessableEntityObjectResultDeclaredType125 - type: string title: WebhooksUnprocessableEntityObjectResultDeclaredType12 WebhooksUnprocessableEntityObjectResultDeclaredType144: oneOf: - type: string title: WebhooksUnprocessableEntityObjectResultDeclaredType144 WebhooksUnprocessableEntityObjectResultDeclaredType146: oneOf: - type: string title: WebhooksUnprocessableEntityObjectResultDeclaredType146 WebhooksUnprocessableEntityObjectResultDeclaredType147: oneOf: - type: string title: WebhooksUnprocessableEntityObjectResultDeclaredType147 WebhooksUnprocessableEntityObjectResultDeclaredType14: oneOf: - type: string - type: string - type: string - type: string - $ref: >- #/components/schemas/WebhooksUnprocessableEntityObjectResultDeclaredType144 - type: string - $ref: >- #/components/schemas/WebhooksUnprocessableEntityObjectResultDeclaredType146 - $ref: >- #/components/schemas/WebhooksUnprocessableEntityObjectResultDeclaredType147 - type: string - type: string title: WebhooksUnprocessableEntityObjectResultDeclaredType14 WebhooksUnprocessableEntityObjectResultDeclaredType17: oneOf: - type: string title: WebhooksUnprocessableEntityObjectResultDeclaredType17 WebhooksUnprocessableEntityObjectResultDeclaredType19: oneOf: - type: string title: WebhooksUnprocessableEntityObjectResultDeclaredType19 WebhooksUnprocessableEntityObjectResultDeclaredType20: oneOf: - type: string title: WebhooksUnprocessableEntityObjectResultDeclaredType20 WebhooksUnprocessableEntityObjectResultDeclaredType: oneOf: - type: string - $ref: >- #/components/schemas/WebhooksUnprocessableEntityObjectResultDeclaredType1 - type: string - type: string - type: string - type: string - type: string - type: string - type: string - $ref: >- #/components/schemas/WebhooksUnprocessableEntityObjectResultDeclaredType9 - $ref: >- #/components/schemas/WebhooksUnprocessableEntityObjectResultDeclaredType10 - type: string - $ref: >- #/components/schemas/WebhooksUnprocessableEntityObjectResultDeclaredType12 - type: string - $ref: >- #/components/schemas/WebhooksUnprocessableEntityObjectResultDeclaredType14 - type: string - type: string - $ref: >- #/components/schemas/WebhooksUnprocessableEntityObjectResultDeclaredType17 - type: string - $ref: >- #/components/schemas/WebhooksUnprocessableEntityObjectResultDeclaredType19 - $ref: >- #/components/schemas/WebhooksUnprocessableEntityObjectResultDeclaredType20 - type: string - type: string title: WebhooksUnprocessableEntityObjectResultDeclaredType WebhooksUnprocessableEntityObjectResultValue: type: object properties: {} title: WebhooksUnprocessableEntityObjectResultValue Webhooks.UnprocessableEntityObjectResult: type: object properties: $type: type: string content_types: type: - array - 'null' items: type: string declared_type: oneOf: - $ref: >- #/components/schemas/WebhooksUnprocessableEntityObjectResultDeclaredType - type: 'null' formatters: type: - array - 'null' items: $ref: '#/components/schemas/Webhooks.IOutputFormatter' status_code: type: - integer - 'null' value: oneOf: - $ref: >- #/components/schemas/WebhooksUnprocessableEntityObjectResultValue - type: 'null' required: - $type title: Webhooks.UnprocessableEntityObjectResult securitySchemes: PAT: type: http scheme: bearer description: Authentication using Personal Access Token (PAT) token OAuth2: type: http scheme: bearer description: OAuth2 authentication using JWT tokens ``` ## SDK Code Examples ```python Webhooks_createSubscription_example import requests url = "https://api.shipbob.com/2025-07/webhook" payload = { "topics": ["order.shipped"], "url": "https://mywebsite.com/shipbob/handler", "description": "string", "secret": "string" } headers = { "Authorization": "Bearer ", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript Webhooks_createSubscription_example const url = 'https://api.shipbob.com/2025-07/webhook'; const options = { method: 'POST', headers: {Authorization: 'Bearer ', 'Content-Type': 'application/json'}, body: '{"topics":["order.shipped"],"url":"https://mywebsite.com/shipbob/handler","description":"string","secret":"string"}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go Webhooks_createSubscription_example package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.shipbob.com/2025-07/webhook" payload := strings.NewReader("{\n \"topics\": [\n \"order.shipped\"\n ],\n \"url\": \"https://mywebsite.com/shipbob/handler\",\n \"description\": \"string\",\n \"secret\": \"string\"\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "Bearer ") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby Webhooks_createSubscription_example require 'uri' require 'net/http' url = URI("https://api.shipbob.com/2025-07/webhook") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = 'Bearer ' request["Content-Type"] = 'application/json' request.body = "{\n \"topics\": [\n \"order.shipped\"\n ],\n \"url\": \"https://mywebsite.com/shipbob/handler\",\n \"description\": \"string\",\n \"secret\": \"string\"\n}" response = http.request(request) puts response.read_body ``` ```java Webhooks_createSubscription_example import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://api.shipbob.com/2025-07/webhook") .header("Authorization", "Bearer ") .header("Content-Type", "application/json") .body("{\n \"topics\": [\n \"order.shipped\"\n ],\n \"url\": \"https://mywebsite.com/shipbob/handler\",\n \"description\": \"string\",\n \"secret\": \"string\"\n}") .asString(); ``` ```php Webhooks_createSubscription_example request('POST', 'https://api.shipbob.com/2025-07/webhook', [ 'body' => '{ "topics": [ "order.shipped" ], "url": "https://mywebsite.com/shipbob/handler", "description": "string", "secret": "string" }', 'headers' => [ 'Authorization' => 'Bearer ', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp Webhooks_createSubscription_example using RestSharp; var client = new RestClient("https://api.shipbob.com/2025-07/webhook"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", "Bearer "); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"topics\": [\n \"order.shipped\"\n ],\n \"url\": \"https://mywebsite.com/shipbob/handler\",\n \"description\": \"string\",\n \"secret\": \"string\"\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift Webhooks_createSubscription_example import Foundation let headers = [ "Authorization": "Bearer ", "Content-Type": "application/json" ] let parameters = [ "topics": ["order.shipped"], "url": "https://mywebsite.com/shipbob/handler", "description": "string", "secret": "string" ] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.shipbob.com/2025-07/webhook")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```